<template>
  <div ref="scrollContainer" class="scroll-container">
    <!-- Pull to refresh -->
    <PullToRefresh ref="pullRefresh" :container="scrollContainer" @refresh="fetchData"></PullToRefresh>

    <!-- Page content -->
    <div class="container mx-auto flex flex-col justify-end justify-items-center" style="margin-bottom: 150px;">

      <!-- Messages -->
      <div class="messages p-5" ref="messagesContainer">

        <!-- Message in case of empty chat -->
        <div role="alert" class="alert shadow-lg py-2 my-3" v-if="list.length > 0">
          <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" class="stroke-info shrink-0 w-6 h-6"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M13 16h-1v-4h-1m1-4h.01M21 12a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg>
          <span>Hi, I'm your assistant! You can ask me anything you want. Once you have entered all the devices, just ask me to create an eco-friendly routine for you by telling me the activities and when the device needs to be turned on.</span>
        </div>

        <component v-for="(message, index) in list" :key="index" :is="message.author === 'user' ? 'ChatBubbleUser' : 'ChatBubbleChatBot' " :message="message.message" />
        <div v-if="loading">
            <ChatBubbleChatBot message="Loading..."/>
        </div>
      </div>

    </div>

    <!-- Input and button -->
    <div class="fixed-bottom-container px-5 py-3 w-full justify-items-center flex flex-nowrap space-x-4 max-w-100 bg-neutral">
      <div class="shrink">
        <button @click="deleteMessages" class="btn btn-secondary rounded-l-full" :disabled="loading">
          <span class="material-symbols-outlined">
            delete
          </span>
        </button>
      </div>
      <div class="grow">
        <input type="text" placeholder="Type here" v-model="userInput" class="input input-bordered w-full input-success" @keyup.enter="sendMessage" :disabled="loading">
      </div>
      <div class="shrink">
        <button @click="sendMessage" class="btn btn-success rounded-e-full" :disabled="loading"> 
          <span class="material-symbols-outlined">
            send
          </span>
        </button>
      </div>
    </div>

    
  </div>
</template>

<script>
  import GenericWidget from '@/components/GenericWidget.vue';
  import PullToRefresh from '@/components/PullToRefresh.vue';
  import PageTitle from '@/components/PageTitle.vue';
  import FloatingActionButton from '@/components/FloatingActionButton.vue';
  import Modal from '@/components/Modal.vue';

  import ROOMS from '@/assets/rooms.json';
  import ICONS from '@/assets/icons.json';
  import ChatBubbleChatBot from '@/components/ChatBubbleChatBot.vue';
  import ChatBubbleUser from '@/components/ChatBubbleUser.vue';

  export default {
      components: {
          ChatBubbleChatBot,
          ChatBubbleUser,
          PullToRefresh
      },
      data() {
        return {
          list: [],
          scrollContainer: {},
          showError: false,
          userInput: '',
          loading: false
        };
      },
      async mounted() {
        // prepare the pull-to-refresh
        this.scrollContainer = this.$refs.scrollContainer
        this.$refs.pullRefresh.init()

        // fetch the data for the first time
        this.fetchData();
        
      },
      updated() {
        // scroll to bottom when the list is updated
        this.scrollToBottom();
      },
      methods: {
        deleteMessages() {
          var self = this;
          self.$axios.delete('/chat', {})
          .then(async (response) => {
            // handle success
            self.list = [];
            self.$forceUpdate();
            self.$toast.success("Chat deleted successfully");
          })
          .catch(function (error) {
            // handle error
            console.log(error);
            self.showError = true;
          })
        },
        fetchData() {
          // Fetching the list of routines
          var self = this;
          self.loading = true;

          self.$axios.get('/chat', {})
          .then(async (response) => {
            // handle success
            self.list = response.data;
            self.$forceUpdate();
          })
          .catch(function (error) {
            // handle error
            console.log(error);
            self.showError = true;
          })
          .finally(function () {
            // always executed
            self.loading = false;
          });

          setTimeout(() => {
                this.$refs.pullRefresh.refreshSuccess()
          }, 1000)
        },
        sendMessage() {
          let userInput = {
              "author": "user",
              "message": this.userInput
            };

          // Check if the input is not empty before sending the message
          if (userInput.message.trim() !== "") {
            // Get the user's input from the input field
            var self = this;

            self.list.push(userInput);

            self.userInput = '';

            self.loading = true;
            
            self.$axios.post('/chat', {
              message: userInput.message
            }).then(async (response) => {
              // handle success
              // Push the new message to the list
              self.loading = true;
              self.showError = false;
              self.list.push(response.data);
              // Clear the input field after sending the message
              
            }).catch(function (error) {
              // handle error
              console.log(error);
              self.showError = true;
              self.$toast.error(error.response.data.message);
            }).finally(function () {
              // always executed
              self.loading = false;
            })

            setTimeout(() => {
                this.$refs.pullRefresh.refreshSuccess()
            }, 1000)
          } else {
            // If the input is empty, show a warning message
            this.$toast.warning("Please type something");
          }
        },
        scrollToBottom() {
        // Srolling the messages container to the bottom each time a send button is clicked and a new message is received
        window.scrollTo(0, document.body.scrollHeight);
        }
      }
  }
</script>


<style scoped>
/* Style the container for text input and button */
.fixed-bottom-container {
  position: fixed;
  bottom: 4rem;
  z-index: 100;
}

/* Style the messages container */
.messages {
  flex: 1;
  overflow-y: auto;
}

/* Add space between text input and button */
.space-x-2 {
  margin-right: 2rem;
}

</style>

